
%if 0

UMBFILL - Allocates all free UMBs
Once written by someone, 2008 disassembled and partly rewritten by C. Masloch. Public Domain.

Assemble with NASM 2.03.01: NASM.EXE -fbin -oUMBFILL.COM UMBFILL.ASM
 (Some other NASM versions should also work)

Report problems to <cm -AT- bttr-software.de> if you experience any and want them fixed by me.

%endif


		cpu 8086
		org 100h

start:
		push cs
		pop ds

		mov ah, 49h			; free memory
		mov es, word [ 2Ch ]		; segment of program's environment block
		int 21h
				; Note: You could argue that the environment block will be freed anyway
				;	because it isn't hacked to have another MCB owner. This is true,
				;	but also brings in a problem: If UMBFILL is loaded high (by means
				;	of such crap like LH), the environment block may also be loaded
				;	high. If it's then freed, UMBFILL didn't fill all UMBs.

		mov ax, 5802h			; get UMB link state
		int 21h
		jc error			; function not supported -->
		push ax				; save UMB link state

		mov ax, 5800h			; get memory allocation strategy
		int 21h
		push ax				; save memory allocation strategy

		mov ax, 5803h			; set UMB link state
		mov bx, 1			; enabled
		int 21h

		mov ax, 5801h			; set memory allocation strategy
		mov bx, 40h			; first fit, UMBs only
		int 21h

		mov dx, 0008h			; in case UMBFILL's own block is the only UMB (see below),
						;  set it's MCB owner value to 0008h (owned by DOS)
		xor cx, cx			; set the UMB counter to zero

allocatenext:
		mov ah, 48h			; allocate memory
		mov bx, 0FFFFh			; requesting this amount will not succeed
		int 21h

		cmp bx, byte 0			; largest block zero ?
		je allblocksdone		;  then no UMBs left

		inc cx				; count how many blocks

		mov ah, 48h
		int 21h				; now do allocate the largest currently available block
						; (not expected to return with error)

		mov dx, ax			; set dx for hackmcb and remember last allocated UMB in dx
		call hackmcb

		jmp short allocatenext


allblocksdone:
		mov ax, 5801h			; (re)set memory allocation strategy
		pop bx				; saved strategy
		int 21h

		mov ax, 5803h			; (re)set UMB link state
		pop bx				; saved UMB link state
		mov bh, 0			;  but only the low byte has meaning
		int 21h

		push cs
		pop ax
		cmp ax, 0A000h			; UMBFILL itself in an UMB ?
		jb checkifany			; no -->

		inc cx				; also count UMBFILL's UMB

		push ds
		call hackmcb			; place the segment of the last UMB in UMBFILL's MCB owner field
					; (filling in another segment _is_ necessary because UMBFILL's own segment
					; is just what DOS will search for when freeing memory.)
		pop ds

checkifany:
		jcxz error			; no UMBs allocated at all ? -->

		mov dx, msg.done
		mov ah, 09h
		int 21h
		
		int 20h				; terminate (but UMBs with hacked MCBs will remain allocated)


error:
		mov dx, msg.noumbs
		mov ah, 09h
		int 21h

		int 20h


hackmcb:		; hack MCB to remain allocated
			; ax = segment of UMB ( (ax-1) is segment of it's MCB)
			; dx = value to fill into the MCB's owner field (mustn't equal cs (UMBFILL's PSP) )
			;
			; doesn't change any register
		dec ax				; ax pointed at the UMB; now MCB of that block
		push ds
		mov ds, ax
		inc ax				; restore ax
		mov word [ 0008h ], "UM"
		mov word [ 000Ah ], "BF"
		mov word [ 000Ch ], "IL"
		mov word [ 000Eh ], "L"		; place the string "UMBFILL",0 into the MCB 8-byte name field
						; (if not done, MEM shows random characters on some DOS versions)

		mov word [ 0001h ], dx		; place the segment of that block itself in it's MCB owner field
						;  this prevents DOS from freeing the UMB when UMBFILL terminates
		pop ds				; restore ds
		retn


msg:
.noumbs:	db "No UMBs available",13,10,36
.done:		db "All UMBs allocated",13,10,36
